(* This file is generated by Why3's Coq driver *)
(* Beware! Only edit allowed sections below    *)
Require Import BuiltIn.
Require BuiltIn.
Require int.Int.
Require list.List.
Require list.Length.
Require list.Mem.
Require map.Map.
Require list.HdTlNoOpt.
Require list.Append.
Require list.Reverse.

(* Why3 assumption *)
Definition unit := unit.

Axiom set : forall (a:Type), Type.
Parameter set_WhyType : forall (a:Type) {a_WT:WhyType a}, WhyType (set a).
Existing Instance set_WhyType.

Parameter mem: forall {a:Type} {a_WT:WhyType a}, a -> (set a) -> Prop.

(* Why3 assumption *)
Definition infix_eqeq {a:Type} {a_WT:WhyType a} (s1:(set a)) (s2:(set
  a)): Prop := forall (x:a), (mem x s1) <-> (mem x s2).

Axiom extensionality : forall {a:Type} {a_WT:WhyType a}, forall (s1:(set a))
  (s2:(set a)), (infix_eqeq s1 s2) -> (s1 = s2).

(* Why3 assumption *)
Definition subset {a:Type} {a_WT:WhyType a} (s1:(set a)) (s2:(set
  a)): Prop := forall (x:a), (mem x s1) -> (mem x s2).

Axiom subset_refl : forall {a:Type} {a_WT:WhyType a}, forall (s:(set a)),
  (subset s s).

Axiom subset_trans : forall {a:Type} {a_WT:WhyType a}, forall (s1:(set a))
  (s2:(set a)) (s3:(set a)), (subset s1 s2) -> ((subset s2 s3) -> (subset s1
  s3)).

Parameter empty: forall {a:Type} {a_WT:WhyType a}, (set a).

(* Why3 assumption *)
Definition is_empty {a:Type} {a_WT:WhyType a} (s:(set a)): Prop :=
  forall (x:a), ~ (mem x s).

Axiom empty_def1 : forall {a:Type} {a_WT:WhyType a}, (is_empty (empty : (set
  a))).

Axiom mem_empty : forall {a:Type} {a_WT:WhyType a}, forall (x:a), ~ (mem x
  (empty : (set a))).

Parameter add: forall {a:Type} {a_WT:WhyType a}, a -> (set a) -> (set a).

Axiom add_def1 : forall {a:Type} {a_WT:WhyType a}, forall (x:a) (y:a),
  forall (s:(set a)), (mem x (add y s)) <-> ((x = y) \/ (mem x s)).

Parameter remove: forall {a:Type} {a_WT:WhyType a}, a -> (set a) -> (set a).

Axiom remove_def1 : forall {a:Type} {a_WT:WhyType a}, forall (x:a) (y:a)
  (s:(set a)), (mem x (remove y s)) <-> ((~ (x = y)) /\ (mem x s)).

Axiom add_remove : forall {a:Type} {a_WT:WhyType a}, forall (x:a) (s:(set
  a)), (mem x s) -> ((add x (remove x s)) = s).

Axiom remove_add : forall {a:Type} {a_WT:WhyType a}, forall (x:a) (s:(set
  a)), ((remove x (add x s)) = (remove x s)).

Axiom subset_remove : forall {a:Type} {a_WT:WhyType a}, forall (x:a) (s:(set
  a)), (subset (remove x s) s).

Parameter union: forall {a:Type} {a_WT:WhyType a}, (set a) -> (set a) -> (set
  a).

Axiom union_def1 : forall {a:Type} {a_WT:WhyType a}, forall (s1:(set a))
  (s2:(set a)) (x:a), (mem x (union s1 s2)) <-> ((mem x s1) \/ (mem x s2)).

Parameter inter: forall {a:Type} {a_WT:WhyType a}, (set a) -> (set a) -> (set
  a).

Axiom inter_def1 : forall {a:Type} {a_WT:WhyType a}, forall (s1:(set a))
  (s2:(set a)) (x:a), (mem x (inter s1 s2)) <-> ((mem x s1) /\ (mem x s2)).

Parameter diff: forall {a:Type} {a_WT:WhyType a}, (set a) -> (set a) -> (set
  a).

Axiom diff_def1 : forall {a:Type} {a_WT:WhyType a}, forall (s1:(set a))
  (s2:(set a)) (x:a), (mem x (diff s1 s2)) <-> ((mem x s1) /\ ~ (mem x s2)).

Axiom subset_diff : forall {a:Type} {a_WT:WhyType a}, forall (s1:(set a))
  (s2:(set a)), (subset (diff s1 s2) s1).

Parameter choose: forall {a:Type} {a_WT:WhyType a}, (set a) -> a.

Axiom choose_def : forall {a:Type} {a_WT:WhyType a}, forall (s:(set a)),
  (~ (is_empty s)) -> (mem (choose s) s).

Parameter cardinal: forall {a:Type} {a_WT:WhyType a}, (set a) -> Z.

Axiom cardinal_nonneg : forall {a:Type} {a_WT:WhyType a}, forall (s:(set a)),
  (0%Z <= (cardinal s))%Z.

Axiom cardinal_empty : forall {a:Type} {a_WT:WhyType a}, forall (s:(set a)),
  ((cardinal s) = 0%Z) <-> (is_empty s).

Axiom cardinal_add : forall {a:Type} {a_WT:WhyType a}, forall (x:a),
  forall (s:(set a)), (~ (mem x s)) -> ((cardinal (add x
  s)) = (1%Z + (cardinal s))%Z).

Axiom cardinal_remove : forall {a:Type} {a_WT:WhyType a}, forall (x:a),
  forall (s:(set a)), (mem x s) -> ((cardinal s) = (1%Z + (cardinal (remove x
  s)))%Z).

Axiom cardinal_subset : forall {a:Type} {a_WT:WhyType a}, forall (s1:(set a))
  (s2:(set a)), (subset s1 s2) -> ((cardinal s1) <= (cardinal s2))%Z.

Axiom subset_eq : forall {a:Type} {a_WT:WhyType a}, forall (s1:(set a))
  (s2:(set a)), (subset s1 s2) -> (((cardinal s1) = (cardinal s2)) ->
  (infix_eqeq s1 s2)).

Axiom cardinal1 : forall {a:Type} {a_WT:WhyType a}, forall (s:(set a)),
  ((cardinal s) = 1%Z) -> forall (x:a), (mem x s) -> (x = (choose s)).

(* Why3 assumption *)
Fixpoint elements {a:Type} {a_WT:WhyType a} (l:(list a)) {struct l}: (set
  a) :=
  match l with
  | Init.Datatypes.nil => (empty : (set a))
  | (Init.Datatypes.cons x r) => (add x (elements r))
  end.

Axiom elements_mem : forall {a:Type} {a_WT:WhyType a}, forall (x:a)
  (l:(list a)), (list.Mem.mem x l) <-> (mem x (elements l)).

(* Why3 assumption *)
Inductive array (a:Type) :=
  | mk_array : Z -> (map.Map.map Z a) -> array a.
Axiom array_WhyType : forall (a:Type) {a_WT:WhyType a}, WhyType (array a).
Existing Instance array_WhyType.
Implicit Arguments mk_array [[a]].

(* Why3 assumption *)
Definition elts {a:Type} {a_WT:WhyType a} (v:(array a)): (map.Map.map Z a) :=
  match v with
  | (mk_array x x1) => x1
  end.

(* Why3 assumption *)
Definition length {a:Type} {a_WT:WhyType a} (v:(array a)): Z :=
  match v with
  | (mk_array x x1) => x
  end.

(* Why3 assumption *)
Definition get {a:Type} {a_WT:WhyType a} (a1:(array a)) (i:Z): a :=
  (map.Map.get (elts a1) i).

(* Why3 assumption *)
Definition set1 {a:Type} {a_WT:WhyType a} (a1:(array a)) (i:Z) (v:a): (array
  a) := (mk_array (length a1) (map.Map.set (elts a1) i v)).

(* Why3 assumption *)
Inductive ref (a:Type) :=
  | mk_ref : a -> ref a.
Axiom ref_WhyType : forall (a:Type) {a_WT:WhyType a}, WhyType (ref a).
Existing Instance ref_WhyType.
Implicit Arguments mk_ref [[a]].

(* Why3 assumption *)
Definition contents {a:Type} {a_WT:WhyType a} (v:(ref a)): a :=
  match v with
  | (mk_ref x) => x
  end.

(* Why3 assumption *)
Definition vertex := Z.

Parameter vertices: (set Z).

Axiom vertices_number : forall (x:Z), (mem x vertices) <-> ((0%Z <= x)%Z /\
  (x < (cardinal vertices))%Z).

Parameter successors: Z -> (list Z).

Axiom successors_vertices : forall (x:Z), (mem x vertices) -> (subset
  (elements (successors x)) vertices).

(* Why3 assumption *)
Definition edge (x:Z) (y:Z): Prop := (mem x vertices) /\ (list.Mem.mem y
  (successors x)).

(* Why3 assumption *)
Inductive path: Z -> (list Z) -> Z -> Prop :=
  | Path_empty : forall (x:Z), (path x Init.Datatypes.nil x)
  | Path_cons : forall (x:Z) (y:Z) (z:Z) (l:(list Z)), (edge x y) -> ((path y
      l z) -> (path x (Init.Datatypes.cons x l) z)).

Axiom path_right_extension : forall (x:Z) (y:Z) (z:Z) (l:(list Z)), (path x l
  y) -> ((edge y z) -> (path x
  (Init.Datatypes.app l (Init.Datatypes.cons y Init.Datatypes.nil)) z)).

Axiom path_right_inversion : forall (x:Z) (z:Z) (l:(list Z)), (path x l z) ->
  (((x = z) /\ (l = Init.Datatypes.nil)) \/ exists y:Z, exists l':(list Z),
  (path x l' y) /\ ((edge y z) /\
  (l = (Init.Datatypes.app l' (Init.Datatypes.cons y Init.Datatypes.nil))))).

Axiom path_trans : forall (x:Z) (y:Z) (z:Z) (l1:(list Z)) (l2:(list Z)),
  (path x l1 y) -> ((path y l2 z) -> (path x (Init.Datatypes.app l1 l2) z)).

Axiom empty_path : forall (x:Z) (y:Z), (path x Init.Datatypes.nil y) ->
  (x = y).

Axiom path_decomposition : forall (x:Z) (y:Z) (z:Z) (l1:(list Z))
  (l2:(list Z)), (path x (Init.Datatypes.app l1 (Init.Datatypes.cons y l2))
  z) -> ((path x l1 y) /\ (path y (Init.Datatypes.cons y l2) z)).

(* Why3 assumption *)
Definition white_vertex (x:Z) (v:(set Z)): Prop := ~ (mem x v).

(* Why3 assumption *)
Inductive wpath: Z -> (list Z) -> Z -> (set Z) -> Prop :=
  | WPath_empty : forall (x:Z) (v:(set Z)), (white_vertex x v) -> (wpath x
      Init.Datatypes.nil x v)
  | WPath_cons : forall (x:Z) (y:Z) (l:(list Z)) (z:Z) (v:(set Z)),
      (white_vertex x v) -> ((edge x y) -> ((wpath y l z v) -> (wpath x
      (Init.Datatypes.cons x l) z v))).

(* Why3 assumption *)
Definition whiteaccess (roots:(set Z)) (b:(set Z)) (v:(set Z)): Prop :=
  forall (z:Z), (mem z b) -> exists x:Z, exists l:(list Z), (mem x roots) /\
  (wpath x l z v).

Axiom whiteaccess_var : forall (r:(set Z)) (r':(set Z)) (b:(set Z)) (v:(set
  Z)), (subset r r') -> ((whiteaccess r b v) -> (whiteaccess r' b v)).

Axiom whiteaccess_covar1 : forall (r:(set Z)) (b:(set Z)) (b':(set Z))
  (v:(set Z)), (subset b b') -> ((whiteaccess r b' v) -> (whiteaccess r b
  v)).

Axiom wpath_covar2 : forall (x:Z) (l:(list Z)) (z:Z) (v:(set Z)) (v':(set
  Z)), (subset v v') -> ((wpath x l z v') -> (wpath x l z v)).

Axiom whiteaccess_covar2 : forall (r:(set Z)) (b:(set Z)) (v:(set Z))
  (v':(set Z)), (subset v v') -> ((whiteaccess r b v') -> (whiteaccess r b
  v)).

Axiom wpath_trans : forall (x:Z) (l:(list Z)) (y:Z) (l':(list Z)) (z:Z)
  (v:(set Z)), (wpath x l y v) -> ((wpath y l' z v) -> (wpath x
  (Init.Datatypes.app l l') z v)).

Axiom whiteaccess_trans : forall (r:(set Z)) (r':(set Z)) (b:(set Z)) (v:(set
  Z)), (whiteaccess r r' v) -> ((whiteaccess r' b v) -> (whiteaccess r b v)).

Axiom whiteaccess_cons : forall (x:Z) (s:(set Z)) (v:(set Z)), (mem x
  vertices) -> ((white_vertex x v) -> ((whiteaccess (elements (successors x))
  s v) -> (whiteaccess (add x (empty : (set Z))) s v))).

Axiom whiteaccess_union : forall (r:(set Z)) (b1:(set Z)) (b2:(set Z))
  (v:(set Z)), (whiteaccess r (union b1 b2) v) <-> ((whiteaccess r b1 v) /\
  (whiteaccess r b2 v)).

Axiom path_wpathempty : forall (y:Z) (l:(list Z)) (z:Z), (wpath y l z
  (empty : (set Z))) -> (path y l z).

Axiom diff_inc : forall {alpha:Type} {alpha_WT:WhyType alpha}, forall (a:(set
  alpha)) (b:(set alpha)) (c:(set alpha)), (subset c b) -> ((subset b a) ->
  ((diff a c) = (union (diff a b) (diff b c)))).

(* Why3 assumption *)
Inductive color :=
  | WHITE : color
  | GRAY : color
  | BLACK : color.
Axiom color_WhyType : WhyType color.
Existing Instance color_WhyType.

Require Import mathcomp.ssreflect.ssreflect.


Require Import mathcomp.ssreflect.ssreflect.
Ltac compress := 
 repeat (match goal with [H1: ?A, H2: ?A |- _] => clear H2 end). 

(* Why3 goal *)
Theorem WP_parameter_dfs1 : forall (x:Z) (col:Z) (col1:(map.Map.map Z color))
  (graph:Z) (graph1:(map.Map.map Z (list Z))) (v:(set Z)),
  (((0%Z <= col)%Z /\ (0%Z <= graph)%Z) /\ (((graph = col) /\
  (col = (cardinal vertices))) /\ ((forall (x1:Z), ((map.Map.get graph1
  x1) = (successors x1))) /\ (((mem x vertices) /\ ((map.Map.get col1
  x) = WHITE)) /\ forall (x1:Z), (mem x1 v) <-> ((mem x1 vertices) /\
  ~ ((map.Map.get col1 x1) = WHITE)))))) -> forall (col0:Z)
  (col01:(map.Map.map Z color)), ((0%Z <= col0)%Z /\ ((col0 = col) /\
  forall (i:Z), ((0%Z <= i)%Z /\ (i < col0)%Z) -> ((map.Map.get col01
  i) = (map.Map.get col1 i)))) -> ((~ (mem x v)) -> (((0%Z <= x)%Z /\
  (x < col)%Z) -> forall (col2:(map.Map.map Z color)), ((0%Z <= col)%Z /\
  (col2 = (map.Map.set col1 x GRAY))) -> forall (v1:(set Z)), (v1 = (add x
  v)) -> (((0%Z <= x)%Z /\ (x < graph)%Z) -> forall (dejavu:(list Z))
  (sons:(list Z)) (v2:(set Z)) (col3:(map.Map.map Z color)), ((subset
  (elements sons) vertices) /\ ((subset v2 vertices) /\ ((forall (z:Z), (mem
  z v2) <-> ((mem z vertices) /\ ~ ((map.Map.get col3 z) = WHITE))) /\
  ((whiteaccess (elements dejavu) (diff v2 (add x v)) v) /\ ((subset (add x
  v) v2) /\
  ((successors x) = (Init.Datatypes.app (Lists.List.rev dejavu) sons))))))) ->
  ((~ (sons = Init.Datatypes.nil)) -> let y := (list.HdTlNoOpt.hd sons) in
  (((0%Z <= col)%Z /\ ((0%Z <= y)%Z /\ (y < col)%Z)) -> (((map.Map.get col3
  y) = WHITE) -> ((((graph = col) /\ (col = (cardinal vertices))) /\
  ((forall (x1:Z), ((map.Map.get graph1 x1) = (successors x1))) /\ (((mem y
  vertices) /\ ((map.Map.get col3 y) = WHITE)) /\ forall (x1:Z), (mem x1
  v2) <-> ((mem x1 vertices) /\ ~ ((map.Map.get col3 x1) = WHITE))))) ->
  forall (v3:(set Z)) (col4:(map.Map.map Z color)), ((0%Z <= col)%Z /\
  ((forall (x1:Z), (mem x1 v3) <-> ((mem x1 vertices) /\ ~ ((map.Map.get col4
  x1) = WHITE))) /\ ((subset v2 v3) /\ (whiteaccess (add y (empty : (set Z)))
  (diff v3 v2) v2)))) -> forall (sons1:(list Z)),
  (sons1 = (list.HdTlNoOpt.tl sons)) -> forall (dejavu1:(list Z)),
  (dejavu1 = (Init.Datatypes.cons y dejavu)) -> (whiteaccess
  (elements dejavu1) (diff v3 (add x v)) v)))))))).

Proof.

 move => x v col col1 [h1 [h2 [[h3 h4] h5]]] h6 [h7 h8] col2 [h9 h10]
        v1 h11 dejavu sons col3 v2 [h12 [h13 [h14 [h15 [h16 h17]]]]] h18 y
        [h19 [h20 h21]] h22 [h23 [[h24 h25] h26]] col4 v3
        [h27 [h28 [h29 h30]]] sons1 h31 dejavu1 dv1_def. 
have diff_v3xv: diff v3 (add x v) = union (diff v3 v2) (diff v2 (add x v)).
- by apply diff_inc.
rewrite diff_v3xv.
have elts_dv1: elements dejavu1 = add y (elements dejavu).
- by rewrite dv1_def.
rewrite elts_dv1.
apply whiteaccess_union; split.
- apply (whiteaccess_var (add y empty)).
  unfold subset.
  move => x' mem_x'yempty.
  apply add_def1; left.
  move/add_def1 :mem_x'yempty => [aa | bb].
  - by [].
  - by apply mem_empty in bb.
  apply (whiteaccess_covar2 _ _ _ v2).
  - apply (subset_trans _ (add x v)).
    + move => x' mem_x'v.
      by apply add_def1; right.
    + by  [].
  - by [].
- apply (whiteaccess_var (elements dejavu)).
  + move => x' mem_x'dv.
    by apply add_def1; right.
  + by [].
Qed.


 move=> x col col1 graph graph1 v [[h1 h2] [[h3 h4] [h5 [[h6 h7] h8]]]] col0
col01 [h9 [h10 h11]] h12 [h13 h14] col2 [h15 h16] v1 h17 [h18 h19] dejavu
sons v2 col3 [h20 [h21 [h22 [h23 [h24 h25]]]]] h26 y [h27 [h28 h29]] h30
[[h31 h32] [h33 [[h34 h35] h36]]] v3 col4 [h37 [h38 [h39 h40]]] sons1 h41
dejavu1 h42.

